#include <stdio.h>
#include <stdlib.h>

void general_one_to_all_bc (int d, int my_id, int source) {
  int my_virtual_id;
  int mask;
  int i;

  my_virtual_id = my_id ^ source;
  mask = (1 << d) - 1;

  for (i = d-1; i >= 0; i--) {
    mask ^= (1 << i);

    if ((my_virtual_id & mask) == 0) {
      if ((my_virtual_id & (1 << i)) == 0) {
	int virtual_dest = my_virtual_id ^ (1 << i);
	printf("Message sent to process %d\n", virtual_dest ^ source);
      } else {
	int virtual_source = my_virtual_id ^ (1 << i);
	printf("Message received from process %d\n", virtual_source ^ source);
      }
    } else {
      printf("doing nothing\n");
    }
  }
}

int main (int argc, char * argv[]) {
  int my_id;
  int d;
  int source;

  if (argc < 2) {
    fprintf(stderr, "usage: %s id dimensions [source]\n", argv[0]);
    exit(EXIT_FAILURE);
  }

  my_id = atoi(argv[1]);
  d = atoi(argv[2]);
  source = argc > 3 ? atoi(argv[3]) : 0;

  fprintf(stderr,
	  "doing general one to all bc rank %d dimensions %d source %d\n",
	  my_id, d, source);

  general_one_to_all_bc(d, my_id, source);
  puts("");

  exit(EXIT_SUCCESS);
}
